#!/usr/bin/perl
#
# fk-scanver.pl$B$N?GCGBP>]$r@)8f(B. 
#
# $Id: fk-governor.pl,v 1.6 2005/11/08 09:06:36 hi-lo Exp $
use strict;

use lib '../lib';
use scoreboard;

use lib '../conf';
use FKSConfig qw($scoreboard_file $report_dir $nkf);

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname (used if -i is NOT given)
Options:
  -h        show this message.
  -i        input hosts file.
  -c        clear scoreboard file. 
  -T        TCP scan (Default)
  -U        UDP scan

Note: scan log is named as $report_dir/"IP or Hostname"."TCP/UDP".log

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_T $opt_U $opt_h $opt_i $opt_c);

getopts('i:TUhc') or die $usage;

die $usage if $opt_h;

clear_scoreboard() if ($opt_c);

my $type = "TCP";
$type = "UDP" if $opt_U;

if (! $opt_i){
  # $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
  my $target = $ARGV[0];
  # $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
  die $usage unless $target;
  
  chomp $target;
  
  # $B3F%*%/%F%C%H$r(B3$B7e$K$9$k(B.   
  my @target_element = split /\./, $target;

  my $new_target = '';
  for my $i (@target_element){
    $i = '0' . $i while ( length($i) < 3);
    $new_target .= "$i.";
  }
  $new_target =~ s/\.$//gc;

  print "'$new_target' <- '$target'\n";
  save_target($target,$type,"$report_dir/$new_target.$type.log","");
}else{
  # -i$B%*%W%7%g%s$,$"$k$H$-(B
  open (DATA , "$nkf --unix -e < $opt_i |") or die "Can't open $opt_i: $!";;

  while (<DATA>){
    chomp;
    next if ( /^\s*$/ );
  
    my $target = $_;

    # $B3F%*%/%F%C%H$r(B3$B7e$K$9$k(B.
    my @target_element = split /\./, $target;

    my $new_target = '';
    for my $i (@target_element){
      $i = '0' . $i while ( length($i) < 3);
      $new_target .= "$i.";
    }
    $new_target =~ s/\.$//gc;

    print "'$new_target' <- '$target'\n";

    save_target($target,$type,"$report_dir/$new_target.$type.log",($opt_i ? $opt_i : ""));
  }
}

exit 0;
