#!/usr/bin/perl
#
# nmap$B$rMxMQ$7$F%*!<%W%s$7$F$$$k%]!<%H$rC5$9(B. 
#
# $Id: fk-scanver.pl,v 1.10 2005/12/13 02:32:00 hi-lo Exp $
use lib '../lib';
use scoreboard;
use misc;

use lib '../conf';
use FKSConfig;

use strict;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname (used if -c is NOT given)
Options:
  -h        show this message.
  -o        scan output logfile. (default: STDOUT)
  -c        Cooperative mode
  -T        TCP scan (Default)
  -U        UDP scan

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_T $opt_U $opt_h $opt_o $opt_c);

getopts('o:TUhc') or die $usage;

die $usage if $opt_h;


# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target;

if ($opt_c){
  # $B6(D4%b!<%I$N;~$O(B, Scoreboard$B%U%!%$%k$+$i?GCGBP>](BIP$B$r<hF@(B
  # TCP/UDP$B$N%?%$%W$b;XDj$9$k(B. (TCP$B$,%G%U%)%k%H(B)
  my $target_data = select_target(($opt_U ? 'UDP' : 'TCP'));
  
  if (! defined $target_data){
    # $B?GCG$r9T$&$Y$-%[%9%H$,B8:_$7$J$$>l9g(B
    exit 1;
  }
  
  # $B?GCGBP>](BIP$B%"%I%l%9(B($B%[%9%HL>(B)$B$NF~<j(B
  $target = get_target_host($target_data);

  # $B=PNO@h$N<hF@(B
  $opt_o = get_output_file($target_data);
  
  # $B6(D4%b!<%I$N>l9g(B, nmap$B$N3+;O$rJs9p(B
  start_nmap($target, ($opt_U ? 'UDP' : 'TCP'));
  
}else{
  # $B6(D4%b!<%I$G$J$$(B(=1$B%[%9%H$N$_$N?GCG(B)
  $target = $ARGV[0];

  # $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
  die $usage unless $target;
}

#-o$B%*%W%7%g%s$,$"$l$P(B, nmap$B$N7k2L$r(B, $B$=$N%U%!%$%k$K=q$-=P$9(B. 
my $nmap_log = "";
$nmap_log = "-oN $opt_o" if ($opt_o);

#$B3+$$$F$$$k%]!<%H$rC5$9$?$a(B, grep-able$B$J%m%0$rF@$k(B. 
my $nmap_glog_file = "$log_dir/$target.". ($opt_U ? 'UDP' : 'TCP') ."_gnmap";
my $nmap_glog = "-oG $nmap_glog_file";

# $B%G%U%)%k%H$G(BTCP$B$N%9%-%c%s$r9T$&(B. 
my $nmap_options = $nmap_tcp_options;
# -u$B%*%W%7%g%s$,$"$l$P(B, UDP$B$N%9%-%c%s$r9T$&(B. 
$nmap_options = $nmap_udp_options if ($opt_U);

my $nmap_command = "$nmap $nmap_options $nmap_log $nmap_glog $target";
print "$nmap_command\n";
# nmap$B$N<B9T(B
eval{
  system("$nmap_command");
};

if($opt_c){
  # $B6(D4%b!<%I$N>l9g(B, nmap$B$N=*N;$rJs9p(B
  finish_nmap($target, ($opt_U ? 'UDP' : 'TCP'));
}

# open$B$J%]!<%H$rCj=P(B

my %scan_targets = get_nmap_grepable_log($nmap_glog_file);
# $B$^$:$O(B, open$B$J$b$N$@$1(B

my $target_ports;

if (exists $scan_targets{$target}->{($opt_U ? 'udp' : 'tcp') . "_num"}->{'open'}){
  # open$B%]!<%H?t(B
  my $target_open_ports_num = 
     $scan_targets{$target}->{($opt_U ? 'udp' : 'tcp') . "_num"}->{'open'};

  # $B>e8B$O2?%]!<%H(B?
  my $max_open_ports_limit = 
    ($opt_U ? $max_open_ports_limit_udp : $max_open_ports_limit_tcp);

  if ($target_open_ports_num > $max_open_ports_limit && $max_open_ports_limit != 0){
    # open$B%]!<%H$,@_Dj%U%!%$%k$GDj$a$?CM$h$jB?$$>l9g$O(B, fk-grubver$B$r8F$S=P$5$J$$(B. 
    print "too many open ports against config-file: \n";
    print "open: $target_open_ports_num port(s), max open ports limit: $max_open_ports_limit\n";
  }else{
    $target_ports = $scan_targets{$target}->{($opt_U ? 'udp' : 'tcp')}->{'open'};
  }
}else{
  print "no open ports are found\n";
}

# $B%?!<%2%C%H$H$J$k%]!<%H$rO"7k$9$k$?$a$K(B','$B$r$R$C$D$1$k(B. 
$target_ports .= ',';

if (exists $scan_targets{$target}->{($opt_U ? 'udp' : 'tcp')}->{'open|filtered'}){
  # open|filtered$B$N%]!<%H$,$"$k>l9g(B. 
  # open|filtered$B$N%]!<%H?t(B
  my $target_open_filtered_ports_num = 
     $scan_targets{$target}->{($opt_U ? 'udp' : 'tcp') . "_num"}->{'open|filtered'};

  # $B>e8B$O2?%]!<%H(B?
  my $max_open_filtered_ports_limit = 
    ($opt_U ? $max_open_filtered_ports_limit_udp : $max_open_filtered_ports_limit_tcp);

  if ($target_open_filtered_ports_num > $max_open_filtered_ports_limit &&
      $max_open_filtered_ports_limit != 0){
    # open$B%]!<%H$,@_Dj%U%!%$%k$GDj$a$?CM$h$jB?$$>l9g$O(B, fk-grubver$B$r8F$S=P$5$J$$(B. 
    print "too many open|filtered ports against config-file: \n";
    print "open|filtered: $target_open_filtered_ports_num port(s), max open|filtered ports limit: $max_open_filtered_ports_limit\n";
  }else{
    # open or filtered$B$r$R$C$D$1$F(B. 
    $target_ports .= $scan_targets{$target}->{($opt_U ? 'udp' : 'tcp')}->{'open|filtered'};
  }
}else{
  print "no open|filtered ports are found\n";
}

# open|filtered$B$,$J$+$C$?>l9g$NBP1~(B. 
$target_ports =~ s/,$//go;

# open$B$J%]!<%H$NCj=P40N;(B

# fk-grubver$B$r8F$S=P$9(B
print "grubbing port banner.....$target:$target_ports:". ($opt_U ? 'UDP' : 'TCP') . "\n";

if ($opt_c){
  #$B6(D4%b!<%I$N>l9g(B, grubver$B$N3+;O$rJs9p(B
  start_grubver($target, ($opt_U ? 'UDP' : 'TCP'));
}

#-o$B%*%W%7%g%s$,$"$l$P(B, nmap$B$N7k2L$r(B, $B$=$N%U%!%$%k$K=q$-=P$9(B.
my $grubver_log = "";
$grubver_log = "-o $opt_o" if ($opt_o);

my $grubver_command = "$fk_grubver -t '$target_ports' $grubver_log "
  . ($opt_U ? '-U' : '-T') . " $target";
print "$grubver_command\n";
eval {
  my @result = `$grubver_command`;
};

if ($opt_c){
  #$B6(D4%b!<%I$N>l9g(B, grubver$B$N=*N;$rJs9p(B
  finish_grubver($target, ($opt_U ? 'UDP' : 'TCP'));
}else{
  # 1$B%[%9%H$N?GCG$N;~$O(B, $B=*N;$rI=<((B
  print "$0 finished!\n\n";
}

exit 0;


