# fk-scan.pl configuration file
# $Id: FKSConfig.pm,v 1.32 2005/12/13 02:39:24 hi-lo Exp $
package FKSConfig;
require Exporter;
use strict;
use vars qw(@ISA @EXPORT);
@ISA = qw(Exporter);

@EXPORT = qw($libexec %port_name %tcp_port_cmd %udp_port_cmd $log_dir $report_dir
             $nkf $nmap $nmap_tcp_options $nmap_udp_options 
             $xprobe $fk_grubver $fk_scanver $no_ports $scoreboard_file
             $max_nmap_tcp $max_nmap_udp $orchestrate_interval
             $max_open_filtered_ports_limit_udp $max_open_filtered_ports_limit_tcp
             $max_open_ports_limit_udp $max_open_ports_limit_tcp );


use strict;

# OۑĂfBNg
# Ō'/'͂Ȃ. 
our $log_dir = '../logs';

# ffʂۑĂfBNg
# Ō'/'͂Ȃ. 
our $report_dir = '../reports';

# L̃c[݂fBNg̎w. 
# Ō'/'͂Ȃ. 
our $libexec = '../libexec';

# T[rX, sR}hw. 
# ̃R}hs\̂, 
# zƂĎw肷. (z\ɂ[]ň͂. )
#
# R}ȟĂяo, Ŏw肵̂̌, 
#   -p ^[Qbg|[g ffΏۃzXg(IPAhX)
# t. 
# 
# unknownƂT[rX, %port_name, T[rX
# ATCĂȂ|[gɑ΂ffŗpR}hw. 
# 
# ȉ͗̕\. R}hĂяo, u
# _TARGET_PORTS_ : I[vĂ\|[g. 
#                  ꍇ, ','ŋ؂Ă. 
# _OPEN_PORTS_ : I[vĂ|[g. ꍇ, ','ŋ؂Ă. 
# _CLOSED_PORTS_ : Ă|[g. ꍇ, ','ŋ؂Ă. 
# _FILTERED_PORTS_ : filteredȃ|[g. ꍇ, ','ŋ؂Ă. 
# ꂼ, Y|[g݂Ȃꍇ, $no_portsŎw肵
# u. 
our $no_ports = "";
#
# TCPp̃XLR}h 
our %tcp_port_cmd = (
  'chargen' => [],
  'smtp' => ['smtp_version.pl', 'smtp_expn_vrfy.pl', 'smtp_relay.pl', 'smtp_rcpt.pl'], 
  'submission' => ['smtp_version.pl', 'smtp_expn_vrfy.pl'], 
  'smtps' => ['smtp_version.pl -s', 'smtp_expn_vrfy.pl -s', 'smtp_relay.pl -s', 
              'smtp_rcpt.pl -s'], 
  'http' => ['http_get.pl', 'http_head.pl', 'http_trace.pl', 'http_track.pl', 
             'http_options.pl', 'http_propfind.pl'],
  'https' => ['http_get.pl -s', 'http_head.pl -s', 'http_trace.pl -s', 
              'http_track.pl -s', 'http_options.pl', 'http_propfind.pl', 
              'ssl_detail.pl'],
  'canna' => ['canna_status.pl'],
  'domain' => ['dns_version.pl -t', 'dns_version.pl -u', 'dns_zonexfer.pl', 
               'dns_reverse.pl -t', 'dns_authors.pl -t'],
  'finger' => ['finger_all.pl', 'finger_user.pl'],
  'ftp' => ['ftp_anonymous.pl','ftp_version.pl'],
  'ftps' => ['ftp_anonymous.pl -s','ftp_version.pl -s'],
  'imap' => ['imap_version.pl'],
  'imaps' => ['imap_version.pl -s'],
  'nfs' => ['nfs_export.pl'],
  'ntp' => ['ntp_date.pl'],
  'nntp' => ['nntp_version.pl'],
  'nntps' => ['nntp_version.pl -s'],
  'pop3' => ['pop3_version.pl'], 
  'pop3s' => ['pop3_version.pl -s'],
  'snmp' => ['snmp_version.pl'],
  'smux' => ['snmp_version.pl'],
  'ssh' => ['ssh_version.pl'],
  'sunrpc' => ['sunrpc_info.pl'], 
  'ident' => ['ident_scan.pl -t _TARGET_PORTS_'], 
  'telnet' => ['telnet_version.pl'],
  'ldap' => ['ldap.pl'],
  'unknown' => ['smtp_version.pl', 'smtp_version.pl -s', 
                'http_head.pl', 'http_trace.pl', 
                'http_head.pl -s', 'http_trace.pl -s', 
                'dns_version.pl', 
                'ftp_version.pl', 'ftp_version.pl -s', 
                'imap_version.pl', 'imap_version.pl -s', 
                'nntp_version.pl', 'nntp_version.pl -s', 
                'pop3_version.pl', 'pop3_version.pl -s', 
                'ssh_version.pl', 
                'telnet_version.pl'
               ],
  'first' => [],
  'last' => [],
  #'last' => ['post_mail.pl -m "_TARGET_HOST_" -s "_TARGET_HOST_"'],
  'all_host' => ['do_cmd.pl \'/usr/bin/xprobe2 -v -T _TARGET_PORTS_ -r _TARGET_HOST_\'',
                 'do_cmd.pl \'/usr/local/bin/icmpquery -t _TARGET_HOST_\'', 
                 'do_cmd.pl \'/usr/local/bin/icmpquery -m _TARGET_HOST_\'', 
                 'do_cmd.pl \'/usr/sbin/traceroute -I _TARGET_HOST_\'', 
                 'do_cmd.pl \'/usr/sbin/traceroute _TARGET_HOST_\'']
);

# canna_status.pl nfs_export.pl snmp_version.pl  sunrpc_info.pl
# |[gԍwłȂ̂, unknownł͐ffȂ. 
#
# UDPp
our %udp_port_cmd = (
  'canna' => ['canna_status.pl'],
  'chargen' => [],
  'domain' => ['dns_version.pl -u', 'dns_reverse.pl -u', 
               'dns_authors.pl -u'],
  'finger' => ['finger_all.pl', 'finger_user.pl'],
  'nfs' => ['nfs_export.pl'],
  'ntp' => ['ntp_date.pl'],
  'nntp' => ['nntp_version.pl'],
  'nntps' => ['nntp_version.pl -s'],
  'snmp' => ['snmp_version.pl'],
  'smux' => ['snmp_version.pl'],
  'sunrpc' => ['sunrpc_info.pl'], 
  'ident' => ['ident_scan.pl -t _TARGET_PORTS_'], 
  'ldap' => ['ldap.pl'],
  'unknown' => [],
  'first' => [],
  'last' => [],
  #'last' => ['post_mail.pl -m "_TARGET_HOST_" -s "_TARGET_HOST_"'],
  'all_host' => ['do_cmd.pl \'/usr/bin/xprobe2 -v -T _TARGET_PORTS_ -r _TARGET_HOST_\'',
                 'do_cmd.pl \'/usr/local/bin/icmpquery -t _TARGET_HOST_\'', 
                 'do_cmd.pl \'/usr/local/bin/icmpquery -m _TARGET_HOST_\'', 
                 'do_cmd.pl \'/usr/sbin/traceroute -I _TARGET_HOST_\'', 
                 'do_cmd.pl \'/usr/sbin/traceroute _TARGET_HOST_\'']
);


# L̂悤ɂ, L`QƂł. 
#for my $i (sort keys %port_cmd){
#  print "$i\n";
#  for my $j ( @{$port_cmd{$i}} ){
#    print "---->$j\n";
#  }
#}

# |[gԍƃT[rX̌т
our %port_name = (
  '25'   => 'smtp',
  '465'  => 'smtps',
  '80'   => 'http',
  '443'  => 'https',
  '5680' => 'canna',
  '53'   => 'domain',
  '79'   => 'finger',
  '21'   => 'ftp',
  '990'  => 'ftps',
  '143'  => 'imap',
  '993'  => 'imaps',
  '2049' => 'nfs',
  '119'  => 'nntp',
  '563'  => 'nntps',
  '110'  => 'pop3',
  '995'  => 'pop3s',
  '161'  => 'snmp',
  '22'   => 'ssh',
  '111'  => 'sunrpc', 
  '113'  => 'ident',
  '23'   => 'telnet',
  '587'  => 'submission',
  '199'  => 'smux',
  '19'   => 'chargen',
  '123'  => 'ntp',
  '389'  => 'ldap'
);
#  '992'  => 'telnets',
#  '636'  => 'ldaps',

#L̂悤ɂ, L`QƂł. 
#for my $i (sort {$a <=> $b} keys %port_name){
#  print "$i:\t".$port_name{$i}."\n";
#}

our $nkf = 'nkf';
our $nmap = 'nmap';
# nmap 3.55
#our $nmap = 'nmap-3.55';

# -sT: TCP scan
# -sU: UDP scan
# -sV: T[rX̃o[W`FbN
# -sR: T[rXRPC̏ꍇ, o[W`FbN (rpcinfo -p̊)
# -O: OS detection
# -P0: don't ping
# -f: tOgpPbggp
# -n: Reverse DNSbNAbvȂ
# -r: XL|[g_ɂȂ. 
# 0ԃ|[gXL
# Strange read error from 192.168.11.20 (10049): No such file or directory
# ȃG[ʔ. 
#our $nmap_tcp_options = '-sT -sV -sR -O -P0 -n -v -T4 -p 1-65535 --initial_rtt_timeout 300 --max_rtt_timeout 500';
our $nmap_tcp_options = '-sT -sV -sR -O -P0 -n -vvv -r -T4 --initial_rtt_timeout 300 --max_rtt_timeout 500 --min_parallelism 10 --max_scan_delay 10';

# nmap-3.55p
#our $nmap_tcp_options = '-sT -O -P0 -n -vvv -r -T4 --initial_rtt_timeout 300 --max_rtt_timeout 500 --min_parallelism 10 --max_scan_delay 10';

#fk-scan.pl̃IvVɂ炸, 
#UDP̃XLȂꍇ, undef;
#our $nmap_udp_options = undef;
#our $nmap_udp_options = '-sU -sV -sR -P0 -n -v -T4 -p 1-65535 --initial_rtt_timeout 300 --max_rtt_timeout 500';
our $nmap_udp_options = '-sU -sV -sR -P0 -n -vvv -r -T4 --initial_rtt_timeout 300 --max_rtt_timeout 500 --min_parallelism 10 --max_scan_delay 10';

# nmap-3.55p
#our $nmap_udp_options = '-sU -P0 -n -vvv -r -T4 --initial_rtt_timeout 300 --max_rtt_timeout 500 --min_parallelism 10 --max_scan_delay 10';

#fk-grubver.pl
our $fk_grubver = './fk-grubver.pl';

#fk-scanver.pl
our $fk_scanver = './fk-scanver.pl';

#[hŗpXRA{[ht@C
our $scoreboard_file = '../logs/scoreboard';

#nmapɂTCPXL̍ő吔
our $max_nmap_tcp = 2;

#nmapɂUDPXL̍ő吔
our $max_nmap_udp = 2;

#fk-orchestrator, snmap̐mFԊu(b). 
our $orchestrate_interval = 30;

# fk-scanver.plfk-grubver.plĂяo, 
# open|filteredُɑꍇ̂, 
# ݒ肵, 𒴂ꍇɂ, fk-grubver.plĂяoȂ. 
# 0ɐݒ肵ꍇ, 󂯂Ȃ. 
our $max_open_filtered_ports_limit_udp = 100;
our $max_open_filtered_ports_limit_tcp = 100; # ̃p^[͂Ȃ. 
# open̏ꍇ
our $max_open_ports_limit_udp = 100;
our $max_open_ports_limit_tcp = 0;


1;
