# Global configuration file
# $Id: GConfig.pm,v 1.28 2005/12/10 17:42:06 hi-lo Exp $
package GConfig;
require Exporter;
use strict;
use vars qw(@ISA @EXPORT %ENV);

@ISA = qw(Exporter);

@EXPORT = qw($timeout $date $dig $finger @finger_user 
  $smtp_my_hostname @expn_username @vrfy_username @rcpt_username 
  $mail_from_addr $rcpt_to_addr $smtp_send_data $ftp_anonymous_user 
  $ftp_anonymous_pass $snmpwalk @snmp_version $showmount $rpcinfo 
  $cannastat $identscanner $fk_cmd $fk_snd $fk_rcv $fk_err
  $http_scapegoat_via_proxy $https_scapegoat_via_proxy 
  $http_via_proxy $https_via_proxy 
  $ntpdate @http_webdav_targets @http_options_targets @http_get_targets
  $ldapsearch $announce_send_to $announce_send_from $announce_subject 
  $announce_cc $announce_reply_to $announce_errors_to $announce_date
  $mailer $nkf $openssl);

use lib '../lib';
  
use Net::SSLeay::Handle qw/shutdown/;

# timeout
our $timeout = 3;

our $date = '/usr/bin/date';

our $dig = '/usr/bin/dig';

our $ntpdate = '/usr/bin/ntpdate';

our $ldapsearch = '/usr/bin/ldapsearch';

our $finger = '/usr/bin/finger';
# FINGER$B$G3NG'$9$k%f!<%6L>$N%j%9%H(B
our @finger_user = ( 'root' , 'admin', 'a b c d e f g h i j k' );

# SMTP$B$N3NG'(B
# HELO/EHLO$B$KB3$/(B, $B%[%9%HL>(B
#our $smtp_my_host = `hostname -f`;
our $smtp_my_hostname = `hostname`; chomp $smtp_my_hostname;
# EXPN$B%3%^%s%I$NM-8z@-3NG'$KMxMQ$9$k%f!<%6L>(B
our @expn_username = ('postmaster', 'lp', 'peekaboo');
# $BF1(BVRFY$BMQ(B
our @vrfy_username = ('root', 'postmaster', 'peekaboo');
# $BF1(BRCPT$BMQ(B
our @rcpt_username = ('root', 'postmaster', 'peekaboo');
# $BIT@5Cf7Q$N3NG'MQ(B($BAw?.85(B)
our $mail_from_addr = '<fk-grubver@fukatani.org>';
# $BIT@5Cf7Q$N3NG'MQ(B($BAw?.@h(B)
our $rcpt_to_addr = '<fk-grubver@fukatani.org>';
# $BIT@5Cf7Q$N3NG'MQ(B ($B%a!<%kK\J8(B)
our $smtp_send_data = "$0 test mail";

# FTP$B$N3NG'(B
our $ftp_anonymous_user = 'anonymous';
our $ftp_anonymous_pass = 'fk-grubver@fukatani.org';

#SNMP$B$N3NG'(B
# snmpwalk 5.x$B0J>e$,I,MW(B
our $snmpwalk = '/usr/bin/snmpwalk';
# SNMP$B$N%P!<%8%g%s(B
our @snmp_version = ('1', '2c', '3');

# NFS$B$N3NG'(B
our $showmount = '/usr/sbin/showmount';

our $rpcinfo = '/usr/sbin/rpcinfo';

our $cannastat = '/usr/local/canna/bin/cannastat';

# nmap$B$N(B3.55$B$^$G$O(B, reverse ident scan$B$,$G$-$k(B. 
# $B%3%^%s%I$N<B9T;~$K(B, $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)$B0J30$K(B
#   -p $B%3%s%^$G6h@Z$C$?(Bopen$B%]!<%H$N%j%9%H(B
# $B$,IU2C$5$l$k2DG=@-$,$"$j$^$9(B. 
our $identscanner = 'nmap-3.55_2 -sT -I -vvv';

# $B%3%^%s%I$N<B9T(B, $B%Q%1%C%H$NAw<u?.$rJ,$+$k$h$&$K$9$k(B
# $B;HMQ;~$K(Beval()$B$5$l$k$N$G(B, $BJ8;zNs$rI=$7$?$$$H$-$O(B2$B=E$K$/$/$k(B.
our $fk_cmd = '"FK#".$port.": "';
our $fk_snd = '"FK#".$port."> "';
our $fk_rcv = '"FK#".$port."< "';
our $fk_err = '"FK#".$port."! "';

# $B%W%m%-%7$N3NG'$K;HMQ(B
our $http_scapegoat_via_proxy = 'www.fukatani.org:80';
our $https_scapegoat_via_proxy = 'www.fukatani.org:443';

# $B%W%m%-%77PM3$N(BHTTP$B$G$_$k(BURL
# $B%[%9%HL>$O(B$http_scapegoat_via_proxy$B$G;XDj$9$k$3$H(B
our $http_via_proxy = "http://$http_scapegoat_via_proxy/";

# $B%W%m%-%77PM3$N(BHTTPS$B$G$_$k(BURL
# $B%[%9%HL>$O(B$https_scapegoat_via_proxy$B$G;XDj$9$k$3$H(B
our $https_via_proxy = "https://$https_scapegoat_via_proxy/";

# Web/DAV$B$N%a%=%C%I$,M-8z$G$"$k$+3NG'$9$k%G%#%l%/%H%j(B
our @http_webdav_targets = ('/', '/scripts/');

# HTTP OPTIONS$B%a%=%C%I$G(B, $B%a%=%C%I$r<hF@$9$k%G%#%l%/%H%j(B
our @http_options_targets = ('*', '/', '/cgi-bin/');

# HTTP GET$B%a%=%C%I$G<hF@$9$k%U%!%$%k(B
our @http_get_targets = ('/acm_fck_err.html', '/');

# $B%a!<%kAw?.(B(post_mail.pl)$B$KMxMQ$9$kJQ?t(B
our $announce_send_to = '<fk-grubver@fukatani.org>';
our $announce_send_from = $ENV{'USER'};
our $announce_subject = "mail from $0";
our $announce_cc = undef;
our $announce_reply_to = undef;
our $announce_errors_to = undef;
our $announce_date = undef;

our $mailer = '/usr/sbin/sendmail';

our $nkf = '/usr/bin/nkf';

our $openssl = '/usr/bin/openssl';
1;
