# $Id: scoreboard.pm,v 1.6 2005/08/27 00:47:49 hi-lo Exp $
package scoreboard;
require Exporter;
use strict;
use Socket;

use lib '../conf';
use FKSConfig qw($scoreboard_file);
use Fcntl qw(:DEFAULT :flock);

use vars qw(@ISA @EXPORT);
@ISA = qw(Exporter);
@EXPORT = qw(save_target select_target get_target_host is_type get_output_file
             start_nmap finish_grubver start_grubver finish_nmap clear_scoreboard
             num_running_nmap num_running_grubver
             num_waiting_nmap num_waiting_grubver num_waiting_target);


# scoreboard file$B$N9=B$(B
# $B?GCGM=Dj%W%m%;%9$NM-L5(B(1:$BM-(B 0:$BL5(B),nmap$B$N>u67(B(1:$B:Q(B 2:$B?GCGCf(B 0:$BL$(B),
#   grubver$B$N>u67(B(1:$B:Q(B 2:$B?GCGCf(B 0:$BL$(B),TCP/UDP,$B%/%i%9(BC$B%M%C%H%o!<%/%"%I%l%9(B,
#   $BBh(B4$B%*%/%F%C%H(B,$BEPO?;~$N%[%9%HL>(B/IP$B%"%I%l%9(B,$B%m%0%U%!%$%k(B(STDOUT$B;~$O6u(B),"$B%3%a%s%H(B"
# $BNc(B: 
# % cat int1.hst
# 192.168.0.1
# 192.168.1.2
# localtest.sample.com
# % cat $scoreboard_file
# 0,0,0,TCP,192.168.0,1,192.168.0.1,outfile.log,"int1.hst"
# 0,0,0,TCP,192.168.1,2,192.168.1.2,outfile.log,"int1.hst"
# 0,0,0,TCP,192.168.2,1,localtest.sample.com,outfile.log,"int1.hst"

sub save_target($$$$){
  # $B%9%3%"%\!<%I%U%!%$%k$K(B, $B?GCGBP>]%[%9%H$rEPO?$9$k(B
  # $BBh(B1$B0z?t(B: $B%[%9%HL>(B/IP$B%"%I%l%9(B
  # $BBh(B2$B0z?t(B: TCP/UDP
  # $BBh(B3$B0z?t(B: $B%m%0%U%!%$%k(B
  # $BBh(B4$B0z?t(B: $B%3%a%s%H(B

  my $target = shift @_;
  my $type = shift @_;
  my $outfile = shift @_;
  my $comment = shift @_;
  $comment = '"'. $comment . '"';
  
  # $B%?!<%2%C%H$,%[%9%HL>$GM?$($i$l$?>l9g$r9M$($F(B....
  # inet_aton$B$O(BDNS$B$b0z$$$F$/$l$k(B.
  my $target_ipn = inet_aton($target);
  # inet_aton$B$N=PNO$r(BIP$B%"%I%l%9$KLa$9(B
  my $target_ip= inet_ntoa($target_ipn);

  # IP$B$r%*%/%F%C%HKh$KJ,$1$k(B
  my @target_ip_sep = split /\./, $target_ip;
  # $BBh(B4$B%*%/%F%C%H$@$1$r<h$k(B
  my $target_ip_4 = pop @target_ip_sep;
  # $BBh(B1$B$+$iBh(B3$B%*%/%F%C%H$r$^$H$a$k(B
  my $network = join ('.', @target_ip_sep);

  my $target_data = 
    join (',', '0','0','0', $type, $network, $target_ip_4, $target, $outfile, $comment);

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT) 
    or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  my $error = 0;
  while ((my $thisline = <SCORE>) && ! $error){
    # $BEPO?$7$h$&$H$9$k%[%9%H$,$9$G$KEPO?$5$l$F$$$J$$$3$H$r3NG'(B
    chomp $thisline;
    $error = 1 if ($thisline =~ 
      /^[0-1],[0-2],[0-2],$type,$network,$target_ip_4,$target,[^,]*,".*"$/);
  }
  print SCORE "$target_data\n" if ( ! $error);
  close (SCORE);
  
  return (! $error) ;
}

sub select_target($){
  # $B8F$S=P$5$l$kKh$K?GCG$r9T$&$Y$-%[%9%H$r4^$`0l9T$rJV$9(B
  # $BBh(B1$B0z?t(B: TCP/UDP

  my $type = shift @_;
  
  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  # $B;CDj(B
  my $return_data = "";

  my $outdata = "";
  
  while (my $thisline = <SCORE>){
    chomp $thisline;

    if ($thisline =~ /^0,/ && is_type($thisline, $type) && $return_data eq ""){
      # $BM=Ls$5$l$F$$$J$$%l%3!<%I$G(B, $B;XDj$5$l$?(BTCP/UDP$B$N%?%$%W$G(B, 
      # $B$^$@M=Ls$9$k%l%3!<%I$,8+$D$+$C$F$$$J$$>l9g(B. 
      # $BM=Ls2DG=$J%[%9%H$r8+$D$1$?$i(B, $B=q$-49$($k(B.
      $thisline =~ s/^0(,[0-2],[0-2],$type,[\.\d]+,\d+,[^,]+,[^,]*,".*")$/1$1/;
      $return_data = $thisline;
    }
    $outdata = $outdata . "$thisline\n";
  }
  
  #$B%U%!%$%k$N@hF,$KLa$k(B
  seek (SCORE, 0, 0);
  #$B%U%!%$%k%5%$%:$r(B0$B$K@Z$j$D$a$k(B. 
  truncate (SCORE, 0);
  print SCORE $outdata;
  close(SCORE);
  return $return_data;
}

sub get_target_host($){
  # $B?GCGBP>]$N(BIP$B%"%I%l%9(B($B%[%9%HL>(B)$B$rJV$9(B
  # $BBh(B1$B0z?t(B: $B%9%3%"%\!<%I%U%!%$%k$N(B1$B9T(B
  my $target_data = shift @_;
  my @target_data = split /,/, $target_data;
  #return $_[4] . "." . $_[5];
  return $target_data[6];
}

sub get_output_file($){
  # $B?GCG7k2L$N=PNO%U%!%$%kJV$9(B. STDOUT$B;~$O(Bundef$B$rJV$9(B
  # $BBh(B1$B0z?t(B: $B%9%3%"%\!<%I%U%!%$%k$N(B1$B9T(B
  my $target_data = shift @_;
  my @target_data = split /,/, $target_data;
  my $outfile = $target_data[7];
  if ($outfile eq ""){
    return undef;
  }else{
    return $outfile;
  }
}

sub is_type($$){
  # $B?GCG$,Bh(B2$B0z?t$GM?$($i$l$?%?%$%W(B(TCP/UDP)$B$N>l9g(B, 1$B$rJV$9(B. 
  # $B$=$l0J30$N>l9g(Bundef$B$rJV$9(B
  # $BBh(B1$B0z?t(B: $B%9%3%"%\!<%I%U%!%$%k$N0l9T(B
  # $BBh(B2$B0z?t(B: TCP/UDP
  my $target_data = shift @_;
  my $type = shift @_;
  my @target_data = split /,/, $target_data;
  return 1 if ($target_data[3] eq $type);
  return undef;
}

sub start_nmap($$){
  # $B%9%3%"%\!<%I%U%!%$%k$K(B, $BEv3:%[%9%H$N?GCG$,3+;O$7$?$3$H$r5-O?$9$k(B. 
  # $BBh(B1$B0z?t(B: $BBP>]%[%9%H(B
  # $BBh(B2$B0z?t(B: TCP/UDP
  my $target = shift @_;
  my $type = shift @_;
  my $outdata = "";

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    # $BEv3:%[%9%H$r8+$D$1$?$i(B, $B=q$-49$($k(B.
    $thisline =~ s/^(\d),(\d),(\d,$type,[\.\d]+,\d+,$target,[^,]*,".*")$/$1,2,$3/;
    $outdata = $outdata . "$thisline\n";
  } 

  #$B%U%!%$%k$N@hF,$KLa$k(B
  seek (SCORE, 0, 0);
  #$B%U%!%$%k%5%$%:$r(B0$B$K@Z$j$D$a$k(B. 
  truncate (SCORE, 0);
  print SCORE $outdata;
  close(SCORE);
}

sub finish_nmap($$){
  # $B%9%3%"%\!<%I%U%!%$%k$K(B, $BEv3:%[%9%H$N?GCG$,=*N;$7$?$3$H$r5-O?$9$k(B. 
  # $BBh(B1$B0z?t(B: $BBP>]%[%9%H(B
  # $BBh(B2$B0z?t(B: TCP/UDP
  my $target = shift @_;
  my $type = shift @_;
  my $outdata = "";

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    # $BEv3:%[%9%H$r8+$D$1$?$i(B, $B=q$-49$($k(B. 
    $thisline =~ s/^(\d),(\d),(\d,$type,[\.\d]+,\d+,$target,[^,]*,".*")$/$1,1,$3/;
    $outdata = $outdata . "$thisline\n";
  } 

  #$B%U%!%$%k$N@hF,$KLa$k(B
  seek (SCORE, 0, 0);
  #$B%U%!%$%k%5%$%:$r(B0$B$K@Z$j$D$a$k(B. 
  truncate (SCORE, 0);
  print SCORE $outdata;
  close(SCORE);
}

sub start_grubver($$){
  # $B%9%3%"%\!<%I%U%!%$%k$K(B, $BEv3:%[%9%H$N?GCG$,3+;O$7$?$3$H$r5-O?$9$k(B. 
  # $BBh(B1$B0z?t(B: $BBP>]%[%9%H(B
  # $BBh(B2$B0z?t(B: TCP/UDP
  my $target = shift @_;
  my $type = shift @_;
  my $outdata = "";

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    # $BEv3:%[%9%H$r8+$D$1$?$i(B, $B=q$-49$($k(B. 
    $thisline =~ s/^(\d,\d),(\d),($type,[\.\d]+,\d+,$target,[^,]*,".*")$/$1,2,$3/;
    $outdata = $outdata . "$thisline\n";
  } 

  #$B%U%!%$%k$N@hF,$KLa$k(B
  seek (SCORE, 0, 0);
  #$B%U%!%$%k%5%$%:$r(B0$B$K@Z$j$D$a$k(B. 
  truncate (SCORE, 0);
  print SCORE $outdata;
  close(SCORE);
}

sub finish_grubver($$){
  # $B%9%3%"%\!<%I%U%!%$%k$K(B, $BEv3:%[%9%H$N?GCG$,=*N;$7$?$3$H$r5-O?$9$k(B. 
  # $BBh(B1$B0z?t(B: $BBP>]%[%9%H(B
  # $BBh(B2$B0z?t(B: TCP/UDP
  my $target = shift @_;
  my $type = shift @_;
  my $outdata = "";

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    # $BEv3:%[%9%H$r8+$D$1$?$i(B, $B=q$-49$($k(B. 
    $thisline =~ s/^(\d,\d),(\d),($type,[\.\d]+,\d+,$target,[^,]*,".*")$/$1,1,$3/;
    $outdata = $outdata . "$thisline\n";
  } 

  #$B%U%!%$%k$N@hF,$KLa$k(B
  seek (SCORE, 0, 0);
  #$B%U%!%$%k%5%$%:$r(B0$B$K@Z$j$D$a$k(B. 
  truncate (SCORE, 0);
  print SCORE $outdata;
  close(SCORE);
}

sub clear_scoreboard(){
  # $B%9%3%"%\!<%I%U%!%$%k$K;D$C$F$$$k?GCG>u67$J$I$r:o=|$9$k(B. 

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  #$B%U%!%$%k$N@hF,$KLa$k(B
  seek (SCORE, 0, 0);
  #$B%U%!%$%k%5%$%:$r(B0$B$K@Z$j$D$a$k(B. 
  truncate (SCORE, 0);
  close(SCORE);
}

sub num_running_nmap($){
  # $B?J9TCf$N(Bnmap$B$N?t$rJV$9(B
  # $BBh(B1$B0z?t(B: TCP/UDP/BOTH

  my $type = shift @_;
  $type = '(?:TCP|UDP)' if ($type eq 'BOTH');
  my $counter = 0;

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    $counter++ if ($thisline =~ /^\d,2,\d,$type,/);
  }

  close (SCORE);
  return $counter;
}

sub num_running_grubver($){
  # $B?J9TCf$N(Bgrubver$B$N?t$rJV$9(B
  # $BBh(B1$B0z?t(B: TCP/UDP/BOTH

  my $type = shift @_;
  $type = '(?:TCP|UDP)' if ($type eq 'BOTH');
  my $counter = 0;

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    $counter++ if ($thisline =~ /^\d,\d,2,$type,/);
  }

  close (SCORE);
  return $counter;
}

sub num_waiting_nmap($){
  # $B?GCGBT$A$N(Bnmap$B$N?t$rJV$9(B
  # $BBh(B1$B0z?t(B: TCP/UDP/BOTH

  my $type = shift @_;
  $type = '(?:TCP|UDP)' if ($type eq 'BOTH');
  my $counter = 0;

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    $counter++ if ($thisline =~ /^\d,0,\d,$type,/);
  }

  close (SCORE);
  return $counter;
}

sub num_waiting_grubver($){
  # $B?GCGBT$A$N(Bgrubver$B$N?t$rJV$9(B
  # $BBh(B1$B0z?t(B: TCP/UDP/BOTH

  my $type = shift @_;
  $type = '(?:TCP|UDP)' if ($type eq 'BOTH');
  my $counter = 0;

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    $counter++ if ($thisline =~ /^\d,\d,0,$type,/);
  }

  close (SCORE);
  return $counter;
}

sub num_waiting_target($){
  # $B?GCGBT$A(B($BM=Ls$5$l$F$$$J$$$b$N(B)$B$N%[%9%H?t$rJV$9(B
  # $BBh(B1$B0z?t(B: TCP/UDP/BOTH

  my $type = shift @_;
  $type = '(?:TCP|UDP)' if ($type eq 'BOTH');
  my $counter = 0;

  sysopen (SCORE, "$scoreboard_file", O_RDWR | O_CREAT)
     or die "can't open scoreboard file: $!";
  flock (SCORE, LOCK_EX) or die "can't locak scoreboard file: $!";

  while (my $thisline = <SCORE> ){
    chomp $thisline;
    $counter++ if ($thisline =~ /^0,\d,\d,$type,/);
  }

  close (SCORE);
  return $counter;
}

1;
