#!/usr/bin/perl
#
# DNS$B%5!<%P$+$i%>!<%sE>Aw$r$9$k%3!<%I(B. 
#
# $Id: dns_zonexfer.pl,v 1.10 2005/09/07 02:26:19 hi-lo Exp $
use lib '../lib';
use ConnectServer;
use Socket;

use lib '../conf';
use GConfig qw($dig $fk_cmd $fk_snd $fk_rcv);

use strict;

my $usage = qq{Usage: $0 [Options] target_dns_server target_domain_name
target_dns_server: IP or Hostname
target_domain_name: domain name (ex.: example.com)
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 53)

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:h') or die $usage;

die $usage if $opt_h;

# $BBP>]%]!<%H$N;XDj$r8!:w(B ($B;XDj$,$J$1$l$P(B53$BHV%]!<%H(B)
my $port = $opt_p ? $opt_p : 53;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target_host = $ARGV[0];

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless $target_host;

# $BBP>]%I%a%$%sL>(B ($B%>!<%sE>Aw$r;n$_$k%I%a%$%sL>(B)
my $domain = undef;
$domain = $ARGV[1] if ($#ARGV >= 1);

# dns$B%5!<%P$,%[%9%HL>$GM?$($i$l$?>l9g$r9M$($F(B....
# inet_aton$B$O(BDNS$B$b0z$$$F$/$l$k(B.
my $target_ipn = inet_aton($target_host);
# inet_aton$B$N=PNO$r(BIP$B%"%I%l%9$KLa$9(B
my $target_ip= inet_ntoa($target_ipn);

if (! defined $domain){
  #$B%I%a%$%sL>$,M?$($i$l$F$$$J$+$C$?>l9g(B. 
  #$B$^$:(B, $B%[%9%HL>$r5U0z$-(B
  my $host = gethostbyaddr($target_ipn, AF_INET);
  #inet_aton$B$N7k2L$r;H$o$:(B, pack("C4", split(/\./, $targethost))
  #$B$H$7$F$b$$$$$1$I(B, IPv6$B$K$J$C$?$H$-$N$3$H$b9M$($F(B, pack$B$O;H$o$J$$(B. 

  # .$B$GJ,3d$7$F(B
  my @dom_tmp = split /\./, $host;

  # $B%[%9%HL>$NItJ,$@$1=|$1$F(B. 
  shift @dom_tmp;

  # $B;D$j$r(B.$B$GO"7k(B. 
  $domain = join ('.', @dom_tmp); 
}

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

my $port_comment = $opt_s ? ' over SSL' : '';
print $OUT "=====BEGIN=====Target: $target_ip:$port$port_comment=====" . `date` ;
# dig$B$r;H$&(B. ($B%$%s%?%i%/%F%#%V$J<B9T$G$O$J$$$N$G(B, $B$3$l$G$h$7$H$9$k(B)
my $command = "$dig \@$target_ip axfr -p $port $domain\. 2>&1";
print $OUT eval ($fk_cmd) . "$command\n";

my @zonexfer = `$command`;

for my $i (@zonexfer){
  print $OUT eval($fk_rcv) . $i;
}

print $OUT "=====END=====Target: $target_ip:$port$port_comment=====" . `date` ;

close(LOG) if $opt_o;

exit 0;




