#!/usr/bin/perl
#
# HTTP$B%5!<%P$+$i(BHEAD /$B$r$H$C$F$/$k%5%s%W%k%3!<%I(B. 
#
# $Id: http_live_select.pl,v 1.9 2005/12/10 17:42:06 hi-lo Exp $
use lib '../lib';
use ConnectServer;

use strict;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 80)

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:h') or die $usage;

die $usage if $opt_h;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target = $ARGV[0];

# $BBP>]%]!<%H$N;XDj$r8!:w(B ($B;XDj$,$J$1$l$P(B80$BHV%]!<%H(B)
my $port = $opt_p ? $opt_p : 80;

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless $target;

# $B%=%1%C%H$N:n@.(B
my $SOCK = connect_server_tcp($target,$port);

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

if ( ! defined $SOCK ){
  print $OUT "cannot establish connection.\n";
  close(LOG) if $opt_o;
  exit 1;
}

# buffer$B$r(BFlush$B$9$k$h$&$K$9$k(B. 
select((select($SOCK), $| = 1)[0]);

my $port_comment = $opt_s ? ' over SSL' : '';
print $OUT "=====BEGIN=====Target: $target:$port$port_comment=====" . `date` ;

#print $SOCK "TRACE / HTTP/1.1\r\nHOST: $target","\r\n\r\n";
#print $OUT "TRACE / HTTP/1.1\nHOST: $target","\n\n";

print $SOCK "HEAD / HTTP/1.0","\xd\xa\xd\xa"; 
# CR=\xd, LF=\xa mac$B$G$O(B, \r$B$H(B \n$B$N0UL#$,5UE>$7$F$$$k(B. 
print $OUT "HEAD / HTTP/1.0","\n\n";

# $B1~Ez%a%C%;!<%8$r<hF@(B
eval{
  $SIG{'ALRM'} = sub { die "timeout" };

  # $B2<5-$N(Bselect$B$@$1$G$O(B, $B%=%1%C%H$K%G!<%?$,$"$k$,(B, $B%P%$%J%j$G(B
  # $B%M%4%7%(!<%7%g%s$,I,MW$J>l9g(B(Telnet$B$J$I(B), $B@h$X?J$s$G$7$^$&(B.
  # $B$7$+$7(B, "$_ = <$SOCK>"$B$,@5>o$K9T$o$l$J$$$?$a(B, $BBT$A>uBV$K4Y$k(B.
  # $B$=$N$?$a(B, alarm()$B$,I,MW(B.

  my $timeout = 30;
  my $r_in = &set_ready_bit($SOCK);
  alarm($timeout);
  my $ret = select($r_in, undef, undef, $timeout); 
  if ( vec  ($r_in, fileno($SOCK), 1) ){
    while (<$SOCK>) {
      chomp;
      print $OUT $_,"\n";
    }
  }else{
    print $OUT "timeout!\n";
  }
  alarm(0);
};
alarm(0);

close($SOCK);
print $OUT "=====END=====Target: $target:$port$port_comment=====" . `date` ;

close(LOG) if $opt_o;

exit 0;




