#!/usr/bin/perl
#
# HTTPS$B%5!<%P$N(BPROPFIND$B%a%=%C%I$N%5%]!<%H$r3NG'$9$k%3!<%I(B 
#
# $Id: http_propfind.pl,v 1.2 2005/12/10 17:42:06 hi-lo Exp $
use lib '../lib';
use ConnectServer;

use lib '../conf';
use GConfig qw($timeout $fk_cmd $fk_snd $fk_rcv $fk_err @http_webdav_targets);

use strict;

# conf$B%U%!%$%k$GFI$_9~$`(B.
#use Net::SSLeay::Handle qw/shutdown/;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 80 (without -s), 443(with -s))
  -s        with SSL. 

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:hs') or die $usage;

die $usage if $opt_h;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target = $ARGV[0];

# $BBP>]%]!<%H$N;XDj$r8!:w(B 
# (-s$B$J$7$G;XDj$,$J$1$l$P(B80, -s$B$"$j$G;XDj$,$J$1$l$P(B443$BHV%]!<%H(B)
my $port = $opt_p ? $opt_p : $opt_s ? 443 : 80;

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless $target;

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

my $port_comment = $opt_s ? ' over SSL' : '';
print $OUT "=====BEGIN=====Target: $target:$port$port_comment=====" . `date` ;

for my $webdav_target (@http_webdav_targets){
    # HTTP/1.1$B$r;H$($P(B, $B2?EY$b%3%M%/%7%g%s$r@\B3(B/$B@ZCG$9$kI,MW$O$J$$$s$@$1$I(B
    # $B%(%i!<$,H/@8$7$?>l9g(B, $B6/@)E*$K%3%M%/%7%g%s$r@Z$i$l$k$3$H$,$"$k$N$G(B
    # $BKh2s(B, $B%3%M%/%7%g%s$r@\B3$9$k$3$H$K$9$k(B.

  # $B%=%1%C%H$N:n@.(B
  my $SOCK_tmp = connect_server_tcp($target,$port);

  if ( ! defined $SOCK_tmp ){
    print $OUT eval ($fk_err) . "cannot establish connection.\n";
    close(LOG) if ($opt_o);
    exit 1;
  }

  my $SOCK = $SOCK_tmp;

  if ($opt_s){
    # -s$B%*%W%7%g%s$,;XDj$5$l$F$$$k>l9g(B.

    $SOCK = enable_ssl_tcp(\$SOCK_tmp, $OUT, $target, $port);
    if (! defined $SOCK){
      print $OUT eval ($fk_err) . "Cannot Enable SSL: $target:$port\n";
      exit 1;
    }
  }

  # buffer$B$r(BFlush$B$9$k$h$&$K$9$k(B. 
  select((select($SOCK), $| = 1)[0]);

  # o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
  # $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
  # $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
  open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

  # $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
  my $OUT = $opt_o ? \*LOG : \*STDOUT;

  eval{
    $SIG{'ALRM'} = sub { die "timeout" }; 

    print $SOCK "PROPFIND " . $webdav_target . " HTTP/1.1\xd\xa" . 
                "Host: $target\xd\xa" . 
                "Depth: 1\xd\xa" . 
                "Content-Type: text/xml; charset=\"uft-8\"\xd\xa" . 
                "Content-Length: 101\xd\xa" . 
                "\xd\xa" . 
                "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\xd\xa" . 
                "<D:propfind xmlns:D=\"DAV:\">\xd\xa" . 
                "  <D:allprop/>\xd\xa" . 
                "</D:propfind>\xd\xa";
      # CR=\xd, LF=\xa mac$B$G$O(B, \r$B$H!@(Bn$B$N0UL#$,5UE>$7$F$$$k(B. 
    print $OUT eval ($fk_snd) . "PROPFIND " . $webdav_target . " HTTP/1.1\n";
    print $OUT eval ($fk_snd) . "Host: $target\n";
    print $OUT eval ($fk_snd) . "Depth: 1\n";
    print $OUT eval ($fk_snd) . "Content-Type: text/xml; charset=\"uft-8\"\n";
    print $OUT eval ($fk_snd) . "Content-Length: 101\n";
    print $OUT eval ($fk_snd) . "\n";
    print $OUT eval ($fk_snd) . "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n";
    print $OUT eval ($fk_snd) . "<D:propfind xmlns:D=\"DAV:\">\n";
    print $OUT eval ($fk_snd) . "  <D:allprop/>\n";
    print $OUT eval ($fk_snd) . "</D:propfind>\n";

    alarm($timeout);

    while (<$SOCK>) {
      chomp;
      print $OUT eval ($fk_rcv) . "$_\n";
    }

    alarm(0);
  };

  alarm(0);
  shutdown($SOCK,1) if ($opt_s); 
  #shutdown()$B$O(BSSL/$BHs(BSSL$B$r6hJL$7$J$$$i$7$$$1$I(B... $BG0$N$?$a(B. 

  close($SOCK);
  print $OUT eval ($fk_cmd) . "Connection closed\n";
}

print $OUT "=====END=====Target: $target:$port$port_comment=====" . `date` ;

close(LOG) if ($opt_o);

exit 0;

