#!/usr/bin/perl
#
# LDAP$B%5!<%P$+$i%G!<%?$r$H$C$F$/$k%3!<%I(B. 
#
# $Id: ldap.pl,v 1.2 2005/11/21 01:38:00 hi-lo Exp $
use lib '../lib';
use ConnectServer;
use Socket;

use lib '../conf';
use GConfig qw($ldapsearch $fk_cmd $fk_snd $fk_rcv $timeout);

use strict;

my $usage = qq{Usage: $0 [Options] target_ldap_server
target_dns_server: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 389)

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:h') or die $usage;

die $usage if $opt_h;

# $BBP>]%]!<%H$N;XDj$r8!:w(B ($B;XDj$,$J$1$l$P(B53$BHV%]!<%H(B)
# (-s$B$J$7$G;XDj$,$J$1$l$P(B389, -s$B$"$j$G;XDj$,$J$1$l$P(B636$BHV%]!<%H(B)
my $port = $opt_p ? $opt_p : $opt_s ? 636 : 389;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target_host = $ARGV[0];

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless  $target_host ;

# dns$B%5!<%P$,%[%9%HL>$GM?$($i$l$?>l9g$r9M$($F(B....
# inet_aton$B$O(BDNS$B$b0z$$$F$/$l$k(B.
my $target_ipn = inet_aton($target_host);
# inet_aton$B$N=PNO$r(BIP$B%"%I%l%9$KLa$9(B
my $target_ip= inet_ntoa($target_ipn);

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

# ldap or ldaps 
my $ldap_type = $opt_s ? 'ldaps' : 'ldap';

my $port_comment = $opt_s ? ' over SSL' : '';
print $OUT "=====BEGIN=====Target: $target_ip:$port$port_comment=====" . `date` ;
# ldapseach$B$r;H$&(B. ($B%$%s%?%i%/%F%#%V$J<B9T$G$O$J$$$N$G(B, $B$3$l$G$h$7$H$9$k(B)

my @commands = ("$ldapsearch -H $ldap_type://$target_ip:$port -x -b '' -s base '*' '+' 2>&1");
push @commands, "$ldapsearch -H $ldap_type://$target_ip:$port -x -b 'cn=schema' -s base '*' '+' 2>&1";
push @commands, "$ldapsearch -H $ldap_type://$target_ip:$port -x -b 'cn=monitor' -s base '*' '+' 2>&1";

for my $command (@commands){
  print $OUT eval ($fk_cmd) . "$command\n";

  my @result = `$command`;

  for my $i (@result){
    print $OUT eval($fk_rcv) . $i;
  }
}

print $OUT "=====END=====Target: $target_ip:$port$port_comment=====" . `date` ;

close(LOG) if $opt_o;

exit 0;

