#!/usr/bin/perl
#
# PROXY$B7PM3$G(BHTTPS$B%5!<%P$+$i%Z!<%8$r$H$C$F$/$k%3!<%I(B. 
#
# $Id: proxy_get_https.pl,v 1.5 2005/12/10 17:42:06 hi-lo Exp $
use lib '../lib';
use ConnectServer;

use lib '../conf';
use GConfig qw($timeout $http_via_proxy $https_via_proxy $http_scapegoat_via_proxy
               $https_scapegoat_via_proxy $fk_cmd $fk_rcv $fk_snd $fk_err);

use strict;

# conf$B%U%!%$%k$GFI$_9~$`(B.
#use Net::SSLeay::Handle qw/shutdown/;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 8080 (without -s), 8443(with -s))
  -s        with SSL. 

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:hs') or die $usage;

die $usage if $opt_h;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target = $ARGV[0];

# $BBP>]%]!<%H$N;XDj$r8!:w(B 
# (-s$B$J$7$G;XDj$,$J$1$l$P(B8080, -s$B$"$j$G;XDj$,$J$1$l$P(B8443$BHV%]!<%H(B)
my $port = $opt_p ? $opt_p : $opt_s ? 8443 : 8080;

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless $target;

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

my $port_comment = $opt_s ? ' over SSL' : '';
print $OUT "=====BEGIN=====Target: $target:$port$port_comment=====" . `date` ;

# $B%=%1%C%H$N:n@.(B
my $SOCK_tmp = connect_server_tcp($target,$port);

if ( ! defined $SOCK_tmp ){
  print $OUT eval ($fk_err) . "cannot establish connection.\n";
  close(LOG) if ($opt_o);
  exit 1;
}

my $SOCK = $SOCK_tmp;

if ($opt_s){
  # -s$B%*%W%7%g%s$,;XDj$5$l$F$$$k>l9g(B.

  $SOCK = enable_ssl_tcp(\$SOCK_tmp, $OUT, $target, $port);
  if (! defined $SOCK){
    print $OUT eval ($fk_err) . "Cannot Enable SSL: $target:$port\n";
    exit 1;
  }
}

# buffer$B$r(BFlush$B$9$k$h$&$K$9$k(B. 
select((select($SOCK), $| = 1)[0]);

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

eval{
  $SIG{'ALRM'} = sub { die "timeout" }; 

  # $B$^$:$O(B, $B@8$1lS$H$J$kAj<j@h$K(BSSL$B@\B3$r9T$&(B. 
  print $SOCK "CONNECT $https_scapegoat_via_proxy HTTP/1.0\xd\xa\xd\xa";
  print $OUT eval ($fk_snd) . "CONNECT $https_scapegoat_via_proxy HTTP/1.0\n";
  print $OUT eval ($fk_snd) . "\n";
  
  # $B2?$+%G!<%?$,JV$C$F$/$k$O$:(B
  eval{
    $SIG{'ALRM'} = sub { die "no_problem" }; 
    # $BAw$jJV$5$l$F$/$k%G!<%?$rBT$D(B
    alarm($timeout / 5);

    while (<$SOCK>) {
	    chomp;
	    print $OUT eval ($fk_rcv) . "$_\n";
    }
    alarm(0);
  };
  alarm (0);

  # $BB3$$$F%=%1%C%H$r(BSSL$B2=(B
  # $B>e$N$d$D$r%3%T!<(B
  my $SSL_SOCK = enable_ssl_tcp(\$SOCK_tmp, $OUT, $target, $port);
  if (! defined $SSL_SOCK){
    print $OUT eval ($fk_err) . "Cannot Enable SSL: $target:$port\n";
    exit 1;
  }
  
  print $SSL_SOCK "GET $https_via_proxy HTTP/1.0","\xd\xa\xd\xa"; 
  # CR=\xd, LF=\xa mac$B$G$O(B, \r$B$H(B \n$B$N0UL#$,5UE>$7$F$$$k(B. 
  print $OUT eval ($fk_snd) . "GET $https_via_proxy HTTP/1.0\n";
  print $OUT eval ($fk_snd) . "\n";

  alarm($timeout);

  while (<$SSL_SOCK>) {
	  chomp;
	  print $OUT eval ($fk_rcv) . "$_\n";
  }

  alarm(0);
  
};

alarm(0);
shutdown($SOCK,1) if ($opt_s); 
#shutdown()$B$O(BSSL/$BHs(BSSL$B$r6hJL$7$J$$$i$7$$$1$I(B... $BG0$N$?$a(B. 

close($SOCK);

print $OUT "=====END=====Target: $target:$port$port_comment=====" . `date` ;

close(LOG) if ($opt_o);

exit 0;

