#!/usr/bin/perl
#
# smtp$B$N(BEXPN, VRFY$B$NM-8z@-$r8!>Z$9$k%3!<%I(B. 
#
# $Id: smtp_expn_vrfy.pl,v 1.14 2005/12/10 17:42:06 hi-lo Exp $
use lib '../lib';
use ConnectServer;
use misc;

use lib '../conf';
use GConfig qw($timeout @expn_username @vrfy_username $smtp_my_hostname 
               $fk_cmd $fk_snd $fk_rcv $fk_err);

use strict;

# conf$B%U%!%$%k$GFI$_9~$`(B.
#use Net::SSLeay::Handle qw/shutdown/;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 25 (without -s), 465(with -s))
  -s        with SSL.

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:hs') or die $usage;

die $usage if $opt_h;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target = $ARGV[0];

# $BBP>]%]!<%H$N;XDj$r8!:w(B 
# (-s$B$J$7$G;XDj$,$J$1$l$P(B25, -s$B$"$j$G;XDj$,$J$1$l$P(B465$BHV%]!<%H(B)
my $port = $opt_p ? $opt_p : $opt_s ? 465 : 25;

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless $target;

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

my $port_comment = $opt_s ? ' over SSL' : '';
print $OUT "=====BEGIN=====Target: $target:$port$port_comment=====" . `date` ;

# $B%=%1%C%H$N:n@.(B
my $SOCK_tmp = connect_server_tcp($target,$port);

if ( ! defined $SOCK_tmp ){
  print $OUT eval ($fk_err) . "cannot establish connection.\n";
  close(LOG) if ($opt_o);
  exit 1;
}

my $SOCK = $SOCK_tmp;

if ($opt_s){
  # -s$B%*%W%7%g%s$,;XDj$5$l$F$$$k>l9g(B.
  $SOCK = enable_ssl_tcp(\$SOCK_tmp, $OUT, $target, $port);
  if (! defined $SOCK){
    print $OUT eval ($fk_err) . "Cannot Enable SSL: $target:$port\n";
    exit 1;
  }
}

# buffer$B$r(BFlush$B$9$k$h$&$K$9$k(B. 
select((select($SOCK), $| = 1)[0]);

# $B$H$j$"$($:(B, $B%3%M%/%7%g%s$,D%$i$l$?$H$-$N%a%C%;!<%8$r<hF@(B

eval{
  $SIG{'ALRM'} = sub { die "timeout" };

  alarm($timeout);
  # $B@\B3$7$?$H$-$N%a%C%;!<%8$@$1$,I,MW(B. 
  $_ = <$SOCK>;
	chomp;
	print $OUT eval ($fk_rcv) . "$_\n";
  alarm(0);

  my $helo_cmd = 'HELO';
  $helo_cmd = 'EHLO' if ($_ =~ /ESMTP/);

  send_smtp_cmd($SOCK, "$helo_cmd $smtp_my_hostname\xd\xa", $OUT, "\$port = $port;");

  # EXPN$B$N8!>Z(B. 
  for my $expn_username (@expn_username){
    send_smtp_cmd($SOCK, "EXPN $expn_username\xd\xa", $OUT, "\$port = $port;");
  }

  # VRFY$B$N8!>Z(B. 
  for my $vrfy_username (@vrfy_username){
    send_smtp_cmd($SOCK, "VRFY $vrfy_username\xd\xa", $OUT, "\$port = $port;");
  }

  send_smtp_cmd($SOCK, "QUIT\xd\xa", $OUT);
};
alarm(0);

shutdown($SOCK,1) if ($opt_s);
#shutdown()$B$O(BSSL/$BHs(BSSL$B$r6hJL$7$J$$$i$7$$$1$I(B... $BG0$N$?$a(B.

close($SOCK);
print $OUT "=====END=====Target: $target:$port$port_comment=====" . `date` ;

close(LOG) if ($opt_o);

exit 0;

