#!/usr/bin/perl
#
# ssh$B$N%P!<%8%g%sHV9f$r<hF@$9$k%3!<%I(B. 
#
# $Id: ssh_version.pl,v 1.8 2005/08/19 08:53:22 hi-lo Exp $
use lib '../lib';
use ConnectServer;

use lib '../conf';
use GConfig qw($timeout $fk_cmd $fk_snd $fk_rcv $fk_err);

use strict;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 22)

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:h') or die $usage;

die $usage if $opt_h;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target = $ARGV[0];

# $BBP>]%]!<%H$N;XDj$r8!:w(B ($B;XDj$,$J$1$l$P(B22$BHV%]!<%H(B)
my $port = $opt_p ? $opt_p : 22;

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless $target;

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

# $B%=%1%C%H$N:n@.(B
my $SOCK = connect_server_tcp($target,$port);

if ( ! defined $SOCK ){
  print $OUT eval ($fk_err) . "cannot establish connection.\n";
  exit 1;
}

# buffer$B$r(BFlush$B$9$k$h$&$K$9$k(B. 
select((select($SOCK), $| = 1)[0]);

my $port_comment = $opt_s ? ' over SSL' : '';
print $OUT "=====BEGIN=====Target: $target:$port$port_comment=====" . `date` ;

eval{
  $SIG{'ALRM'} = sub { die "timeout" };

  alarm($timeout);
  # ssh$B$O@\B3$7$?$i%P!<%8%g%sHV9f$rJV$7$F$/$k(B. 
  $_ = <$SOCK>;
	chomp;
	print $OUT eval ($fk_rcv) . "$_\n";
  alarm(0);

  # $B2~9T$rAw$C$F$d$k$H(B, $B%3%M%/%7%g%s$,@Z$i$l$k(B. 
  print $SOCK "\xd\xa"; # CR=\xd, LF=\xa mac$B$G$O(B, \r$B$H!@(Bn$B$N0UL#$,5UE>$7$F$$$k(B. 
  print $OUT "\n";
  # $B$3$l$G%3%M%/%7%g%s$,@Z$i$l$k$O$:(B. 
  # $B@Z$i$l$J$+$C$?$H$7$F$b(B, $B$3$N%9%/%j%W%H$,BT$A>uBV$KF~$k$3$H$O$J$$$h$&$J(B
  # $B%3!<%G%#%s%0$K$J$C$F$$$k(B. 
};
alarm(0);

close($SOCK);
print $OUT "=====END=====Target: $target:$port$port_comment=====" . `date` ;

close(LOG) if $opt_o;

exit 0;

